1. regristreer gcp een applicatie en genereer client keys

2. zet een webserver functie op die de client redirect naar google met de onderstaande GET parameters

3. plaats een knop of hyperlink op de home pagina die naar de bovenste functie redirect

4. de flask applicatie redirect de client naar de onderstaande parameter, de onderstaande GET request wordt dus door de
   client uitgevoerd

```
GET https://accounts.google.com/o/oauth2/v2/auth?
    client_id=CLIENTID &            # de client id van je applicatie die je bij stap 1 hebt gegenereerd
    response_type=code &            # je vraagt google om een code(deze kan je met je app secret van stap 1 een authorization token verkrijgen)
    scope=openid profile email &    # de data die je opvraagt(openid=jwt profile=naam, foto enz... email=email) 
    redirect_uri=CALLBACK &         # waar google de client naar redirect met parameters
    nonce=RANDOM                    # om een replay attack te voorkomen

RESPONSE                            # de onderstaande krijgt je applicatie terug op je callback
GET http://localhost:5000/callback  # een get request naar de callback met de volgende arguments
    code=AUTHORIZATIONCODE &        # de code die je moet uitwisselen met je secret key
    scope=email profile &           # de scopes die je mag opvragen
    authuser=0 &                    #
    prompt=none                     #
```
Hiervan moeten we de code parameter gebruiken

5. Nadat je de authorization code hebt verkregen moet je die omzetten in een (refresh)token, hierbij krijg je ook een
jwt met alle gebruiker profiel data.
   
6. De onderstaande request moet je applicatie in de achtergrond uitvoeren om de code om te wisselen naar bruikbare data
   
```
POST https://oauth2.googleapis.com/token?
    code=AUTORIZATIONCODE &         # de code die je van de client hebt gekregen
    client_id=CLIENTID    &         # je applicatie id
    client_secret=CSECRET &         # je applicatie secret
    redirect_uri=CALLBACK &         # wordt niet gebruikt wel verplicht
    grant_type=authorization_code   # de type code die je meegeeft
    
RESPONSE
200 OK
{
	"access_token": "ACCESS_TOKEN",                                                                                     # deze kan je gebruiken om extra profiel data op te vragen bij de google profile api
	"expires_in": 3312,                                                                                                 # de tijd voor hoelang de access_token geldig is in seconden
	"scope": "https://www.googleapis.com/auth/userinfo.profile openid https://www.googleapis.com/auth/userinfo.email",  # de scopes die je access_token mag benaderen
	"token_type": "Bearer",                                                                                             # de onderstaande id_token type
	"id_token": "aaaa.bbbbbbbbbbbbbbbb.cccccccccc"                                                                      # de JWT, als je deze checkt met de keys van google is de authorisatie voldoende, in het midden van de 2 punten is de profiel informatie te vinden encoded in base64
}
```

7. in principe voor puur openid authenticatie moet je de client de jwt toesturen, hiermee authentiseerd de client dan
met je applicatie zolang de jwt geldig is.
   
8. aan de flask kant moet je de Authorization header van elke request van de client controleren of de meegegeven JWT
Bearer token nog geldig is, door google is uitgegeven, geldend voor jouw applicatie, hier zijn libraries voor te vinden.